<template>
  <div :class="{'has-logo':showLogo}" :style="cssVars">
    <logo v-if="showLogo" :collapse="isCollapse" />
    <el-scrollbar wrap-class="scrollbar-wrapper">
      <el-menu
        :default-active="activeMenu"
        :collapse="isCollapse"
        :background-color="variables.menuBg"
        :text-color="variables.menuText"
        :unique-opened="false"
        :active-text-color="variables.menuActiveText"
        :collapse-transition="false"
        mode="vertical"
      >
        <sidebar-item v-for="route in permission_routes" :key="route.path" :item="route" :base-path="route.path" />
      </el-menu>
    </el-scrollbar>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import Logo from './Logo'
import SidebarItem from './SidebarItem'

export default {
  components: { SidebarItem, Logo },
  computed: {
    ...mapGetters([
      'permission_routes',
      'sidebar',
      'theme'
    ]),
    activeMenu() {
      const route = this.$route
      const { meta, path } = route
      // if set path, the sidebar will highlight the path you set
      if (meta.activeMenu) {
        return meta.activeMenu
      }
      return path
    },
    showLogo() {
      return this.$store.state.settings.sidebarLogo
    },
    cssVars() {
      switch (this.theme) {
        case 'orange':
          return {
            '--menuBg': '#3e2723',
            '--menuHover': '#4e342e',
            '--subMenuBg': '#4e342e',
            '--subMenuHover': '#5d4037',
            '--menuText': '#ffecb3',
            '--menuActiveText': '#ff9800',
            '--subMenuActiveText': '#ff9800'
          }
        case 'light':
          return {
            '--menuBg': '#ffffff',
            '--menuHover': '#f5f5f5',
            '--subMenuBg': '#ffffff',
            '--subMenuHover': '#f5f5f5',
            '--menuText': '#333333',
            '--menuActiveText': '#409EFF',
            '--subMenuActiveText': '#303133'
          }
        default:
          return {
            '--menuBg': '#2b333e',
            '--menuHover': '#1f262f',
            '--subMenuBg': '#1f262f',
            '--subMenuHover': '#001528',
            '--menuText': '#bfcbd9',
            '--menuActiveText': '#409EFF',
            '--subMenuActiveText': '#f4f4f5'
          }
      }
    },
    variables() {
      const vars = this.cssVars
      return {
        menuBg: vars['--menuBg'],
        menuText: vars['--menuText'],
        menuActiveText: vars['--menuActiveText']
      }
    },
    isCollapse() {
      return !this.sidebar.opened
    }
  }
}
</script>
